# coding: utf-8

"""
    OpenFEC

    This API allows you to explore the way candidates and committees fund their campaigns.    The FEC API is a RESTful web service supporting full-text and field-specific searches on FEC data. [Bulk downloads](https://www.fec.gov/data/advanced/?tab=bulk-data) are available on the current site. Information is tied to the underlying forms by file ID and image ID. Data is updated nightly.    There is a lot of data, but a good place to start is to use search to find interesting candidates and committees. Then, you can use their IDs to find report or line item details with the other endpoints. If you are interested in individual donors, check out contributor information in schedule_a.    Get an [API key here](https://api.data.gov/signup/). That will enable you to place up to 1,000 calls an hour. Each call is limited to 100 results per page. You can email questions, comments or a request to get a key for 120 calls per minute to [APIinfo@fec.gov](mailto:apiinfo@fec.gov). You can also ask questions and discuss the data in the [FEC data Google Group](https://groups.google.com/forum/#!forum/fec-data). API changes will also be added to this group in advance of the change.    The model definitions and schema are available at [/swagger](/swagger/). This is useful for making wrappers and exploring the data.    A few restrictions limit the way you can use FEC data. For example, you can’t use contributor lists for commercial purposes or to solicit donations. [Learn more here](https://www.fec.gov/updates/sale-or-use-contributor-information/).    [View our source code](https://github.com/fecgov/openFEC). We welcome issues and pull requests!  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import
import re  # noqa: F401
import sys  # noqa: F401

import six  # noqa: F401
import nulltype  # noqa: F401

from openfec_sdk.model_utils import (  # noqa: F401
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    int,
    none_type,
    str,
    validate_get_composed_info,
)


class CommitteeTotalsHouseSenate(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    @cached_property
    def openapi_types():
        """
        This must be a class method so a model may have properties that are
        of type self, this ensures that we don't create a cyclic import

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'cycle': (int,),  # noqa: E501
            'all_other_loans': (float, none_type,),  # noqa: E501
            'candidate_contribution': (float, none_type,),  # noqa: E501
            'cash_on_hand_beginning_period': (float, none_type,),  # noqa: E501
            'committee_designation': (str, none_type,),  # noqa: E501
            'committee_designation_full': (str, none_type,),  # noqa: E501
            'committee_id': (str, none_type,),  # noqa: E501
            'committee_name': (str, none_type,),  # noqa: E501
            'committee_type': (str, none_type,),  # noqa: E501
            'committee_type_full': (str, none_type,),  # noqa: E501
            'contribution_refunds': (float, none_type,),  # noqa: E501
            'contributions': (float, none_type,),  # noqa: E501
            'coverage_end_date': (datetime, none_type,),  # noqa: E501
            'coverage_start_date': (datetime, none_type,),  # noqa: E501
            'disbursements': (float, none_type,),  # noqa: E501
            'individual_contributions': (float, none_type,),  # noqa: E501
            'individual_itemized_contributions': (float, none_type,),  # noqa: E501
            'individual_unitemized_contributions': (float, none_type,),  # noqa: E501
            'last_beginning_image_number': (str,),  # noqa: E501
            'last_cash_on_hand_end_period': (float,),  # noqa: E501
            'last_debts_owed_by_committee': (float, none_type,),  # noqa: E501
            'last_debts_owed_to_committee': (float, none_type,),  # noqa: E501
            'last_report_type_full': (str, none_type,),  # noqa: E501
            'last_report_year': (int, none_type,),  # noqa: E501
            'loan_repayments': (float, none_type,),  # noqa: E501
            'loan_repayments_candidate_loans': (float, none_type,),  # noqa: E501
            'loan_repayments_other_loans': (float, none_type,),  # noqa: E501
            'loans': (float, none_type,),  # noqa: E501
            'loans_made_by_candidate': (float, none_type,),  # noqa: E501
            'net_contributions': (float, none_type,),  # noqa: E501
            'net_operating_expenditures': (float, none_type,),  # noqa: E501
            'offsets_to_operating_expenditures': (float, none_type,),  # noqa: E501
            'operating_expenditures': (float, none_type,),  # noqa: E501
            'other_disbursements': (float, none_type,),  # noqa: E501
            'other_political_committee_contributions': (float, none_type,),  # noqa: E501
            'other_receipts': (float, none_type,),  # noqa: E501
            'party_full': (str, none_type,),  # noqa: E501
            'pdf_url': (str,),  # noqa: E501
            'political_party_committee_contributions': (float, none_type,),  # noqa: E501
            'receipts': (float, none_type,),  # noqa: E501
            'refunded_individual_contributions': (float, none_type,),  # noqa: E501
            'refunded_other_political_committee_contributions': (float, none_type,),  # noqa: E501
            'refunded_political_party_committee_contributions': (float, none_type,),  # noqa: E501
            'report_form': (str,),  # noqa: E501
            'transaction_coverage_date': (date,),  # noqa: E501
            'transfers_from_other_authorized_committee': (float, none_type,),  # noqa: E501
            'transfers_to_other_authorized_committee': (float, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None

    attribute_map = {
        'cycle': 'cycle',  # noqa: E501
        'all_other_loans': 'all_other_loans',  # noqa: E501
        'candidate_contribution': 'candidate_contribution',  # noqa: E501
        'cash_on_hand_beginning_period': 'cash_on_hand_beginning_period',  # noqa: E501
        'committee_designation': 'committee_designation',  # noqa: E501
        'committee_designation_full': 'committee_designation_full',  # noqa: E501
        'committee_id': 'committee_id',  # noqa: E501
        'committee_name': 'committee_name',  # noqa: E501
        'committee_type': 'committee_type',  # noqa: E501
        'committee_type_full': 'committee_type_full',  # noqa: E501
        'contribution_refunds': 'contribution_refunds',  # noqa: E501
        'contributions': 'contributions',  # noqa: E501
        'coverage_end_date': 'coverage_end_date',  # noqa: E501
        'coverage_start_date': 'coverage_start_date',  # noqa: E501
        'disbursements': 'disbursements',  # noqa: E501
        'individual_contributions': 'individual_contributions',  # noqa: E501
        'individual_itemized_contributions': 'individual_itemized_contributions',  # noqa: E501
        'individual_unitemized_contributions': 'individual_unitemized_contributions',  # noqa: E501
        'last_beginning_image_number': 'last_beginning_image_number',  # noqa: E501
        'last_cash_on_hand_end_period': 'last_cash_on_hand_end_period',  # noqa: E501
        'last_debts_owed_by_committee': 'last_debts_owed_by_committee',  # noqa: E501
        'last_debts_owed_to_committee': 'last_debts_owed_to_committee',  # noqa: E501
        'last_report_type_full': 'last_report_type_full',  # noqa: E501
        'last_report_year': 'last_report_year',  # noqa: E501
        'loan_repayments': 'loan_repayments',  # noqa: E501
        'loan_repayments_candidate_loans': 'loan_repayments_candidate_loans',  # noqa: E501
        'loan_repayments_other_loans': 'loan_repayments_other_loans',  # noqa: E501
        'loans': 'loans',  # noqa: E501
        'loans_made_by_candidate': 'loans_made_by_candidate',  # noqa: E501
        'net_contributions': 'net_contributions',  # noqa: E501
        'net_operating_expenditures': 'net_operating_expenditures',  # noqa: E501
        'offsets_to_operating_expenditures': 'offsets_to_operating_expenditures',  # noqa: E501
        'operating_expenditures': 'operating_expenditures',  # noqa: E501
        'other_disbursements': 'other_disbursements',  # noqa: E501
        'other_political_committee_contributions': 'other_political_committee_contributions',  # noqa: E501
        'other_receipts': 'other_receipts',  # noqa: E501
        'party_full': 'party_full',  # noqa: E501
        'pdf_url': 'pdf_url',  # noqa: E501
        'political_party_committee_contributions': 'political_party_committee_contributions',  # noqa: E501
        'receipts': 'receipts',  # noqa: E501
        'refunded_individual_contributions': 'refunded_individual_contributions',  # noqa: E501
        'refunded_other_political_committee_contributions': 'refunded_other_political_committee_contributions',  # noqa: E501
        'refunded_political_party_committee_contributions': 'refunded_political_party_committee_contributions',  # noqa: E501
        'report_form': 'report_form',  # noqa: E501
        'transaction_coverage_date': 'transaction_coverage_date',  # noqa: E501
        'transfers_from_other_authorized_committee': 'transfers_from_other_authorized_committee',  # noqa: E501
        'transfers_to_other_authorized_committee': 'transfers_to_other_authorized_committee',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_from_server',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, cycle, _check_type=True, _from_server=False, _path_to_item=(), _configuration=None, _visited_composed_classes=(), **kwargs):  # noqa: E501
        """committee_totals_house_senate.CommitteeTotalsHouseSenate - a model defined in OpenAPI

        Args:
            cycle (int):  Filter records to only those that are applicable to a given two-year period. This cycle follows the traditional House election cycle and subdivides the presidential and Senate elections into comparable two-year blocks. The cycle begins with an odd year and is named for its ending, even year.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _from_server (bool): True if the data is from the server
                                False if the data is from the client (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            all_other_loans (float, none_type): [optional]  # noqa: E501
            candidate_contribution (float, none_type): [optional]  # noqa: E501
            cash_on_hand_beginning_period (float, none_type): [optional]  # noqa: E501
            committee_designation (str, none_type): The one-letter designation code of the organization:          - A authorized by a candidate          - J joint fundraising committee          - P principal campaign committee of a candidate          - U unauthorized          - B lobbyist/registrant PAC          - D leadership PAC . [optional]  # noqa: E501
            committee_designation_full (str, none_type): The one-letter designation code of the organization:          - A authorized by a candidate          - J joint fundraising committee          - P principal campaign committee of a candidate          - U unauthorized          - B lobbyist/registrant PAC          - D leadership PAC . [optional]  # noqa: E501
            committee_id (str, none_type):  A unique identifier assigned to each committee or filer registered with the FEC. In general committee id&#39;s begin with the letter C which is followed by eight digits. . [optional]  # noqa: E501
            committee_name (str, none_type): The name of the committee. If a committee changes its name,     the most recent name will be shown. Committee names are not unique. Use committee_id     for looking up records.. [optional]  # noqa: E501
            committee_type (str, none_type): The one-letter type code of the organization:         - C communication cost         - D delegate         - E electioneering communication         - H House         - I independent expenditor (person or group)         - N PAC - nonqualified         - O independent expenditure-only (super PACs)         - P presidential         - Q PAC - qualified         - S Senate         - U single candidate independent expenditure         - V PAC with non-contribution account, nonqualified         - W PAC with non-contribution account, qualified         - X party, nonqualified         - Y party, qualified         - Z national party non-federal account . [optional]  # noqa: E501
            committee_type_full (str, none_type): The one-letter type code of the organization:         - C communication cost         - D delegate         - E electioneering communication         - H House         - I independent expenditor (person or group)         - N PAC - nonqualified         - O independent expenditure-only (super PACs)         - P presidential         - Q PAC - qualified         - S Senate         - U single candidate independent expenditure         - V PAC with non-contribution account, nonqualified         - W PAC with non-contribution account, qualified         - X party, nonqualified         - Y party, qualified         - Z national party non-federal account . [optional]  # noqa: E501
            contribution_refunds (float, none_type): [optional]  # noqa: E501
            contributions (float, none_type): Contribution. [optional]  # noqa: E501
            coverage_end_date (datetime, none_type): [optional]  # noqa: E501
            coverage_start_date (datetime, none_type): [optional]  # noqa: E501
            disbursements (float, none_type): Disbursements. [optional]  # noqa: E501
            individual_contributions (float, none_type): [optional]  # noqa: E501
            individual_itemized_contributions (float, none_type): Individual itemized contributions are from individuals whose aggregate contributions total over $200 per individual per year. Be aware, some filers choose to itemize donations $200 or less.. [optional]  # noqa: E501
            individual_unitemized_contributions (float, none_type): Unitemized contributions are made individuals whose aggregate contributions total $200 or less per individual per year. Be aware, some filers choose to itemize donations $200 or less and in that case those donations will appear in the itemized total.. [optional]  # noqa: E501
            last_beginning_image_number (str): [optional]  # noqa: E501
            last_cash_on_hand_end_period (float): [optional]  # noqa: E501
            last_debts_owed_by_committee (float, none_type): [optional]  # noqa: E501
            last_debts_owed_to_committee (float, none_type): [optional]  # noqa: E501
            last_report_type_full (str, none_type): [optional]  # noqa: E501
            last_report_year (int, none_type): [optional]  # noqa: E501
            loan_repayments (float, none_type): [optional]  # noqa: E501
            loan_repayments_candidate_loans (float, none_type): [optional]  # noqa: E501
            loan_repayments_other_loans (float, none_type): [optional]  # noqa: E501
            loans (float, none_type): [optional]  # noqa: E501
            loans_made_by_candidate (float, none_type): [optional]  # noqa: E501
            net_contributions (float, none_type): [optional]  # noqa: E501
            net_operating_expenditures (float, none_type): [optional]  # noqa: E501
            offsets_to_operating_expenditures (float, none_type): [optional]  # noqa: E501
            operating_expenditures (float, none_type): [optional]  # noqa: E501
            other_disbursements (float, none_type): [optional]  # noqa: E501
            other_political_committee_contributions (float, none_type): [optional]  # noqa: E501
            other_receipts (float, none_type): [optional]  # noqa: E501
            party_full (str, none_type): Party affiliated with a candidate or committee. [optional]  # noqa: E501
            pdf_url (str): [optional]  # noqa: E501
            political_party_committee_contributions (float, none_type): [optional]  # noqa: E501
            receipts (float, none_type): [optional]  # noqa: E501
            refunded_individual_contributions (float, none_type): [optional]  # noqa: E501
            refunded_other_political_committee_contributions (float, none_type): [optional]  # noqa: E501
            refunded_political_party_committee_contributions (float, none_type): [optional]  # noqa: E501
            report_form (str): [optional]  # noqa: E501
            transaction_coverage_date (date): [optional]  # noqa: E501
            transfers_from_other_authorized_committee (float, none_type): [optional]  # noqa: E501
            transfers_to_other_authorized_committee (float, none_type): [optional]  # noqa: E501
        """

        self._data_store = {}
        self._check_type = _check_type
        self._from_server = _from_server
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.cycle = cycle
        for var_name, var_value in six.iteritems(kwargs):
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
