# coding: utf-8

"""
    OpenFEC

    This API allows you to explore the way candidates and committees fund their campaigns.    The FEC API is a RESTful web service supporting full-text and field-specific searches on FEC data. [Bulk downloads](https://www.fec.gov/data/advanced/?tab=bulk-data) are available on the current site. Information is tied to the underlying forms by file ID and image ID. Data is updated nightly.    There is a lot of data, but a good place to start is to use search to find interesting candidates and committees. Then, you can use their IDs to find report or line item details with the other endpoints. If you are interested in individual donors, check out contributor information in schedule_a.    Get an [API key here](https://api.data.gov/signup/). That will enable you to place up to 1,000 calls an hour. Each call is limited to 100 results per page. You can email questions, comments or a request to get a key for 120 calls per minute to [APIinfo@fec.gov](mailto:apiinfo@fec.gov). You can also ask questions and discuss the data in the [FEC data Google Group](https://groups.google.com/forum/#!forum/fec-data). API changes will also be added to this group in advance of the change.    The model definitions and schema are available at [/swagger](/swagger/). This is useful for making wrappers and exploring the data.    A few restrictions limit the way you can use FEC data. For example, you can’t use contributor lists for commercial purposes or to solicit donations. [Learn more here](https://www.fec.gov/updates/sale-or-use-contributor-information/).    [View our source code](https://github.com/fecgov/openFEC). We welcome issues and pull requests!  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import
import re  # noqa: F401
import sys  # noqa: F401

import six  # noqa: F401
import nulltype  # noqa: F401

from openfec_sdk.model_utils import (  # noqa: F401
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    int,
    none_type,
    str,
    validate_get_composed_info,
)


class EFilings(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    @cached_property
    def openapi_types():
        """
        This must be a class method so a model may have properties that are
        of type self, this ensures that we don't create a cyclic import

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'amended_by': (int,),  # noqa: E501
            'amendment_chain': ([int],),  # noqa: E501
            'amendment_number': (int, none_type,),  # noqa: E501
            'amends_file': (int, none_type,),  # noqa: E501
            'beginning_image_number': (str,),  # noqa: E501
            'committee_id': (str, none_type,),  # noqa: E501
            'committee_name': (str, none_type,),  # noqa: E501
            'coverage_end_date': (date, none_type,),  # noqa: E501
            'coverage_start_date': (date, none_type,),  # noqa: E501
            'csv_url': (str,),  # noqa: E501
            'document_description': (str,),  # noqa: E501
            'ending_image_number': (str,),  # noqa: E501
            'fec_file_id': (str,),  # noqa: E501
            'fec_url': (str,),  # noqa: E501
            'file_number': (int,),  # noqa: E501
            'filed_date': (date, none_type,),  # noqa: E501
            'form_type': (str, none_type,),  # noqa: E501
            'html_url': (str,),  # noqa: E501
            'is_amended': (bool,),  # noqa: E501
            'load_timestamp': (datetime, none_type,),  # noqa: E501
            'most_recent': (bool,),  # noqa: E501
            'most_recent_filing': (int,),  # noqa: E501
            'pdf_url': (str,),  # noqa: E501
            'receipt_date': (datetime, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None

    attribute_map = {
        'amended_by': 'amended_by',  # noqa: E501
        'amendment_chain': 'amendment_chain',  # noqa: E501
        'amendment_number': 'amendment_number',  # noqa: E501
        'amends_file': 'amends_file',  # noqa: E501
        'beginning_image_number': 'beginning_image_number',  # noqa: E501
        'committee_id': 'committee_id',  # noqa: E501
        'committee_name': 'committee_name',  # noqa: E501
        'coverage_end_date': 'coverage_end_date',  # noqa: E501
        'coverage_start_date': 'coverage_start_date',  # noqa: E501
        'csv_url': 'csv_url',  # noqa: E501
        'document_description': 'document_description',  # noqa: E501
        'ending_image_number': 'ending_image_number',  # noqa: E501
        'fec_file_id': 'fec_file_id',  # noqa: E501
        'fec_url': 'fec_url',  # noqa: E501
        'file_number': 'file_number',  # noqa: E501
        'filed_date': 'filed_date',  # noqa: E501
        'form_type': 'form_type',  # noqa: E501
        'html_url': 'html_url',  # noqa: E501
        'is_amended': 'is_amended',  # noqa: E501
        'load_timestamp': 'load_timestamp',  # noqa: E501
        'most_recent': 'most_recent',  # noqa: E501
        'most_recent_filing': 'most_recent_filing',  # noqa: E501
        'pdf_url': 'pdf_url',  # noqa: E501
        'receipt_date': 'receipt_date',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_from_server',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, _check_type=True, _from_server=False, _path_to_item=(), _configuration=None, _visited_composed_classes=(), **kwargs):  # noqa: E501
        """e_filings.EFilings - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _from_server (bool): True if the data is from the server
                                False if the data is from the client (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            amended_by (int): [optional]  # noqa: E501
            amendment_chain ([int]): [optional]  # noqa: E501
            amendment_number (int, none_type):  Number of times the report has been amended. . [optional]  # noqa: E501
            amends_file (int, none_type):  For amendments, this file_number is the file_number of the previous report that is being amended. See amended_by for the most recent version of the report. . [optional]  # noqa: E501
            beginning_image_number (str): [optional]  # noqa: E501
            committee_id (str, none_type):  A unique identifier assigned to each committee or filer registered with the FEC. In general committee id&#39;s begin with the letter C which is followed by eight digits. . [optional]  # noqa: E501
            committee_name (str, none_type): The name of the committee. If a committee changes its name,     the most recent name will be shown. Committee names are not unique. Use committee_id     for looking up records.. [optional]  # noqa: E501
            coverage_end_date (date, none_type): Ending date of the reporting period. [optional]  # noqa: E501
            coverage_start_date (date, none_type): Beginning date of the reporting period. [optional]  # noqa: E501
            csv_url (str): [optional]  # noqa: E501
            document_description (str): [optional]  # noqa: E501
            ending_image_number (str): [optional]  # noqa: E501
            fec_file_id (str): [optional]  # noqa: E501
            fec_url (str): [optional]  # noqa: E501
            file_number (int): Filing ID number. [optional]  # noqa: E501
            filed_date (date, none_type): Timestamp of electronic or paper record that FEC received. [optional]  # noqa: E501
            form_type (str, none_type): The form where the underlying data comes from, for example, Form 1 would appear as F1:     - F1   Statement of Organization     - F1M  Notification of Multicandidate Status     - F2   Statement of Candidacy     - F3   Report of Receipts and Disbursements for an Authorized Committee     - F3P  Report of Receipts and Disbursements by an Authorized Committee of a Candidate for     The Office of President or Vice President     - F3L  Report of Contributions Bundled by Lobbyists/Registrants and Lobbyist/Registrant PACs     - F3X  Report of Receipts and Disbursements for other than an Authorized Committee     - F4   Report of Receipts and Disbursements for a Committee or Organization Supporting a Nomination Convention     - F5   Report of Independent Expenditures Made and Contributions Received     - F6   48 Hour Notice of Contributions/Loans Received     - F7   Report of Communication Costs by Corporations and Membership Organizations     - F8   Debt Settlement Plan     - F9   24 Hour Notice of Disbursements for Electioneering Communications     - F13  Report of Donations Accepted for Inaugural Committee     - F99  Miscellaneous Text     - FRQ  Request for Additional Information . [optional]  # noqa: E501
            html_url (str): [optional]  # noqa: E501
            is_amended (bool): [optional]  # noqa: E501
            load_timestamp (datetime, none_type): Date the information was loaded into the FEC systems. This can be affected by reseting systems and other factors, refer to receipt_date for the day that the FEC received the paper or electronic document. Keep in mind that paper filings take more time to process and there can be a lag between load_date and receipt_date. This field can be helpful to identify paper records that have been processed recently.. [optional]  # noqa: E501
            most_recent (bool): [optional]  # noqa: E501
            most_recent_filing (int): [optional]  # noqa: E501
            pdf_url (str): [optional]  # noqa: E501
            receipt_date (datetime, none_type): Date the FEC received the electronic or paper record. [optional]  # noqa: E501
        """

        self._data_store = {}
        self._check_type = _check_type
        self._from_server = _from_server
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in six.iteritems(kwargs):
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
