# coding: utf-8

"""
    OpenFEC

    This API allows you to explore the way candidates and committees fund their campaigns.    The FEC API is a RESTful web service supporting full-text and field-specific searches on FEC data. [Bulk downloads](https://www.fec.gov/data/advanced/?tab=bulk-data) are available on the current site. Information is tied to the underlying forms by file ID and image ID. Data is updated nightly.    There is a lot of data, but a good place to start is to use search to find interesting candidates and committees. Then, you can use their IDs to find report or line item details with the other endpoints. If you are interested in individual donors, check out contributor information in schedule_a.    Get an [API key here](https://api.data.gov/signup/). That will enable you to place up to 1,000 calls an hour. Each call is limited to 100 results per page. You can email questions, comments or a request to get a key for 120 calls per minute to [APIinfo@fec.gov](mailto:apiinfo@fec.gov). You can also ask questions and discuss the data in the [FEC data Google Group](https://groups.google.com/forum/#!forum/fec-data). API changes will also be added to this group in advance of the change.    The model definitions and schema are available at [/swagger](/swagger/). This is useful for making wrappers and exploring the data.    A few restrictions limit the way you can use FEC data. For example, you can’t use contributor lists for commercial purposes or to solicit donations. [Learn more here](https://www.fec.gov/updates/sale-or-use-contributor-information/).    [View our source code](https://github.com/fecgov/openFEC). We welcome issues and pull requests!  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import
import re  # noqa: F401
import sys  # noqa: F401

import six  # noqa: F401
import nulltype  # noqa: F401

from openfec_sdk.model_utils import (  # noqa: F401
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    int,
    none_type,
    str,
    validate_get_composed_info,
)


class PresidentialSummary(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    @cached_property
    def openapi_types():
        """
        This must be a class method so a model may have properties that are
        of type self, this ensures that we don't create a cyclic import

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'candidate_contributions_less_repayments': (float, none_type,),  # noqa: E501
            'candidate_id': (str, none_type,),  # noqa: E501
            'candidate_last_name': (str, none_type,),  # noqa: E501
            'candidate_name': (str, none_type,),  # noqa: E501
            'candidate_party_affiliation': (str, none_type,),  # noqa: E501
            'cash_on_hand_end': (float, none_type,),  # noqa: E501
            'committee_designation': (str, none_type,),  # noqa: E501
            'committee_id': (str, none_type,),  # noqa: E501
            'committee_name': (str, none_type,),  # noqa: E501
            'committee_type': (str, none_type,),  # noqa: E501
            'debts_owed_by_committee': (float, none_type,),  # noqa: E501
            'disbursements_less_offsets': (float, none_type,),  # noqa: E501
            'election_year': (int, none_type,),  # noqa: E501
            'exempt_legal_accounting_disbursement': (float, none_type,),  # noqa: E501
            'federal_funds': (float, none_type,),  # noqa: E501
            'fundraising_disbursements': (float, none_type,),  # noqa: E501
            'individual_contributions_less_refunds': (float, none_type,),  # noqa: E501
            'net_receipts': (float, none_type,),  # noqa: E501
            'offsets_to_operating_expenditures': (float, none_type,),  # noqa: E501
            'operating_expenditures': (float, none_type,),  # noqa: E501
            'other_disbursements': (float, none_type,),  # noqa: E501
            'pac_contributions_less_refunds': (float, none_type,),  # noqa: E501
            'party_contributions_less_refunds': (float, none_type,),  # noqa: E501
            'repayments_loans_made_by_candidate': (float, none_type,),  # noqa: E501
            'repayments_other_loans': (float, none_type,),  # noqa: E501
            'rounded_net_receipts': (float, none_type,),  # noqa: E501
            'total_contribution_refunds': (float, none_type,),  # noqa: E501
            'total_loan_repayments_made': (float, none_type,),  # noqa: E501
            'transfers_from_affiliated_committees': (float, none_type,),  # noqa: E501
            'transfers_to_other_authorized_committees': (float, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None

    attribute_map = {
        'candidate_contributions_less_repayments': 'candidate_contributions_less_repayments',  # noqa: E501
        'candidate_id': 'candidate_id',  # noqa: E501
        'candidate_last_name': 'candidate_last_name',  # noqa: E501
        'candidate_name': 'candidate_name',  # noqa: E501
        'candidate_party_affiliation': 'candidate_party_affiliation',  # noqa: E501
        'cash_on_hand_end': 'cash_on_hand_end',  # noqa: E501
        'committee_designation': 'committee_designation',  # noqa: E501
        'committee_id': 'committee_id',  # noqa: E501
        'committee_name': 'committee_name',  # noqa: E501
        'committee_type': 'committee_type',  # noqa: E501
        'debts_owed_by_committee': 'debts_owed_by_committee',  # noqa: E501
        'disbursements_less_offsets': 'disbursements_less_offsets',  # noqa: E501
        'election_year': 'election_year',  # noqa: E501
        'exempt_legal_accounting_disbursement': 'exempt_legal_accounting_disbursement',  # noqa: E501
        'federal_funds': 'federal_funds',  # noqa: E501
        'fundraising_disbursements': 'fundraising_disbursements',  # noqa: E501
        'individual_contributions_less_refunds': 'individual_contributions_less_refunds',  # noqa: E501
        'net_receipts': 'net_receipts',  # noqa: E501
        'offsets_to_operating_expenditures': 'offsets_to_operating_expenditures',  # noqa: E501
        'operating_expenditures': 'operating_expenditures',  # noqa: E501
        'other_disbursements': 'other_disbursements',  # noqa: E501
        'pac_contributions_less_refunds': 'pac_contributions_less_refunds',  # noqa: E501
        'party_contributions_less_refunds': 'party_contributions_less_refunds',  # noqa: E501
        'repayments_loans_made_by_candidate': 'repayments_loans_made_by_candidate',  # noqa: E501
        'repayments_other_loans': 'repayments_other_loans',  # noqa: E501
        'rounded_net_receipts': 'rounded_net_receipts',  # noqa: E501
        'total_contribution_refunds': 'total_contribution_refunds',  # noqa: E501
        'total_loan_repayments_made': 'total_loan_repayments_made',  # noqa: E501
        'transfers_from_affiliated_committees': 'transfers_from_affiliated_committees',  # noqa: E501
        'transfers_to_other_authorized_committees': 'transfers_to_other_authorized_committees',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_from_server',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, _check_type=True, _from_server=False, _path_to_item=(), _configuration=None, _visited_composed_classes=(), **kwargs):  # noqa: E501
        """presidential_summary.PresidentialSummary - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _from_server (bool): True if the data is from the server
                                False if the data is from the client (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            candidate_contributions_less_repayments (float, none_type):  candidate contributions less repayments . [optional]  # noqa: E501
            candidate_id (str, none_type):  A unique identifier assigned to each candidate registered with the FEC. If a person runs for several offices, that person will have separate candidate IDs for each office.   -P00000001    All candidates   -P00000002    Democrasts   -P00000003    Republicans . [optional]  # noqa: E501
            candidate_last_name (str, none_type):  Candidate last name . [optional]  # noqa: E501
            candidate_name (str, none_type): Name of candidate running for office. [optional]  # noqa: E501
            candidate_party_affiliation (str, none_type): Three-letter code for the party affiliated with a candidate or committee. For example, DEM for Democratic Party and REP for Republican Party.. [optional]  # noqa: E501
            cash_on_hand_end (float, none_type): Ending cash balance on the most recent filing. [optional]  # noqa: E501
            committee_designation (str, none_type): The one-letter designation code of the organization:          - A authorized by a candidate          - J joint fundraising committee          - P principal campaign committee of a candidate          - U unauthorized          - B lobbyist/registrant PAC          - D leadership PAC . [optional]  # noqa: E501
            committee_id (str, none_type):  A unique identifier assigned to each candidate registered with the FEC. If a person runs for several offices, that person will have separate candidate IDs for each office. . [optional]  # noqa: E501
            committee_name (str, none_type): The name of the committee. If a committee changes its name,     the most recent name will be shown. Committee names are not unique. Use committee_id     for looking up records.. [optional]  # noqa: E501
            committee_type (str, none_type): The one-letter type code of the organization:         - C communication cost         - D delegate         - E electioneering communication         - H House         - I independent expenditor (person or group)         - N PAC - nonqualified         - O independent expenditure-only (super PACs)         - P presidential         - Q PAC - qualified         - S Senate         - U single candidate independent expenditure         - V PAC with non-contribution account, nonqualified         - W PAC with non-contribution account, qualified         - X party, nonqualified         - Y party, qualified         - Z national party non-federal account . [optional]  # noqa: E501
            debts_owed_by_committee (float, none_type): Debts owed by the committee. [optional]  # noqa: E501
            disbursements_less_offsets (float, none_type):  disbursements less offsets . [optional]  # noqa: E501
            election_year (int, none_type): Year of election. [optional]  # noqa: E501
            exempt_legal_accounting_disbursement (float, none_type):  exempt legal accounting disbursement . [optional]  # noqa: E501
            federal_funds (float, none_type): Federal funds: Public funding of presidential elections means that qualified presidential candidates                 receive federal government funds to pay for the valid expenses of their political campaigns                 in both the primary and general elections.. [optional]  # noqa: E501
            fundraising_disbursements (float, none_type):  fundraising disbursements . [optional]  # noqa: E501
            individual_contributions_less_refunds (float, none_type):  individual contributions less refunds . [optional]  # noqa: E501
            net_receipts (float, none_type):  Contributions received . [optional]  # noqa: E501
            offsets_to_operating_expenditures (float, none_type): Offsets to operating expenditures. [optional]  # noqa: E501
            operating_expenditures (float, none_type): Total operating expenditures. [optional]  # noqa: E501
            other_disbursements (float, none_type): Other disbursements. [optional]  # noqa: E501
            pac_contributions_less_refunds (float, none_type):  pac contributions less refunds . [optional]  # noqa: E501
            party_contributions_less_refunds (float, none_type):  party contributions less refunds . [optional]  # noqa: E501
            repayments_loans_made_by_candidate (float, none_type):  repayments loans made by candidate . [optional]  # noqa: E501
            repayments_other_loans (float, none_type):  repayments other loans . [optional]  # noqa: E501
            rounded_net_receipts (float, none_type):  Net receipts, in millions . [optional]  # noqa: E501
            total_contribution_refunds (float, none_type):  total contribution refunds . [optional]  # noqa: E501
            total_loan_repayments_made (float, none_type):  total loan repayments made . [optional]  # noqa: E501
            transfers_from_affiliated_committees (float, none_type):  transfers from affiliated committees . [optional]  # noqa: E501
            transfers_to_other_authorized_committees (float, none_type):  transfers to other authorized committees . [optional]  # noqa: E501
        """

        self._data_store = {}
        self._check_type = _check_type
        self._from_server = _from_server
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in six.iteritems(kwargs):
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
