# coding: utf-8

"""
    OpenFEC

    This API allows you to explore the way candidates and committees fund their campaigns.    The FEC API is a RESTful web service supporting full-text and field-specific searches on FEC data. [Bulk downloads](https://www.fec.gov/data/advanced/?tab=bulk-data) are available on the current site. Information is tied to the underlying forms by file ID and image ID. Data is updated nightly.    There is a lot of data, but a good place to start is to use search to find interesting candidates and committees. Then, you can use their IDs to find report or line item details with the other endpoints. If you are interested in individual donors, check out contributor information in schedule_a.    Get an [API key here](https://api.data.gov/signup/). That will enable you to place up to 1,000 calls an hour. Each call is limited to 100 results per page. You can email questions, comments or a request to get a key for 120 calls per minute to [APIinfo@fec.gov](mailto:apiinfo@fec.gov). You can also ask questions and discuss the data in the [FEC data Google Group](https://groups.google.com/forum/#!forum/fec-data). API changes will also be added to this group in advance of the change.    The model definitions and schema are available at [/swagger](/swagger/). This is useful for making wrappers and exploring the data.    A few restrictions limit the way you can use FEC data. For example, you can’t use contributor lists for commercial purposes or to solicit donations. [Learn more here](https://www.fec.gov/updates/sale-or-use-contributor-information/).    [View our source code](https://github.com/fecgov/openFEC). We welcome issues and pull requests!  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import
import re  # noqa: F401
import sys  # noqa: F401

import six  # noqa: F401
import nulltype  # noqa: F401

from openfec_sdk.model_utils import (  # noqa: F401
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    int,
    none_type,
    str,
    validate_get_composed_info,
)
try:
    from openfec_sdk.models import committee_history
except ImportError:
    committee_history = sys.modules[
        'openfec_sdk.models.committee_history']


class ScheduleB(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('spender_committee_designation',): {
            'max_length': 1,
        },
        ('spender_committee_org_type',): {
            'max_length': 1,
        },
        ('spender_committee_type',): {
            'max_length': 1,
        },
    }

    additional_properties_type = None

    @cached_property
    def openapi_types():
        """
        This must be a class method so a model may have properties that are
        of type self, this ensures that we don't create a cyclic import

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'amendment_indicator': (str, none_type,),  # noqa: E501
            'amendment_indicator_desc': (str, none_type,),  # noqa: E501
            'back_reference_schedule_id': (str, none_type,),  # noqa: E501
            'back_reference_transaction_id': (str, none_type,),  # noqa: E501
            'beneficiary_committee_name': (str, none_type,),  # noqa: E501
            'candidate_first_name': (str, none_type,),  # noqa: E501
            'candidate_id': (str, none_type,),  # noqa: E501
            'candidate_last_name': (str, none_type,),  # noqa: E501
            'candidate_middle_name': (str, none_type,),  # noqa: E501
            'candidate_name': (str, none_type,),  # noqa: E501
            'candidate_office': (str, none_type,),  # noqa: E501
            'candidate_office_description': (str, none_type,),  # noqa: E501
            'candidate_office_district': (str, none_type,),  # noqa: E501
            'candidate_office_state': (str, none_type,),  # noqa: E501
            'candidate_office_state_full': (str, none_type,),  # noqa: E501
            'candidate_prefix': (str, none_type,),  # noqa: E501
            'candidate_suffix': (str, none_type,),  # noqa: E501
            'category_code': (str, none_type,),  # noqa: E501
            'category_code_full': (str, none_type,),  # noqa: E501
            'comm_dt': (date, none_type,),  # noqa: E501
            'committee': (committee_history.CommitteeHistory,),  # noqa: E501
            'committee_id': (str, none_type,),  # noqa: E501
            'conduit_committee_city': (str, none_type,),  # noqa: E501
            'conduit_committee_name': (str, none_type,),  # noqa: E501
            'conduit_committee_state': (str, none_type,),  # noqa: E501
            'conduit_committee_street1': (str, none_type,),  # noqa: E501
            'conduit_committee_street2': (str, none_type,),  # noqa: E501
            'conduit_committee_zip': (int, none_type,),  # noqa: E501
            'disbursement_amount': (float, none_type,),  # noqa: E501
            'disbursement_date': (date, none_type,),  # noqa: E501
            'disbursement_description': (str, none_type,),  # noqa: E501
            'disbursement_purpose_category': (str, none_type,),  # noqa: E501
            'disbursement_type': (str, none_type,),  # noqa: E501
            'disbursement_type_description': (str, none_type,),  # noqa: E501
            'election_type': (str, none_type,),  # noqa: E501
            'election_type_full': (str, none_type,),  # noqa: E501
            'entity_type': (str, none_type,),  # noqa: E501
            'entity_type_desc': (str, none_type,),  # noqa: E501
            'fec_election_type_desc': (str, none_type,),  # noqa: E501
            'fec_election_year': (str, none_type,),  # noqa: E501
            'file_number': (int, none_type,),  # noqa: E501
            'filing_form': (str, none_type,),  # noqa: E501
            'image_number': (str,),  # noqa: E501
            'line_number': (str, none_type,),  # noqa: E501
            'line_number_label': (str, none_type,),  # noqa: E501
            'link_id': (int, none_type,),  # noqa: E501
            'load_date': (datetime, none_type,),  # noqa: E501
            'memo_code': (str, none_type,),  # noqa: E501
            'memo_code_full': (str, none_type,),  # noqa: E501
            'memo_text': (str, none_type,),  # noqa: E501
            'memoed_subtotal': (bool,),  # noqa: E501
            'national_committee_nonfederal_account': (str, none_type,),  # noqa: E501
            'original_sub_id': (str,),  # noqa: E501
            'payee_employer': (str, none_type,),  # noqa: E501
            'payee_first_name': (str, none_type,),  # noqa: E501
            'payee_last_name': (str, none_type,),  # noqa: E501
            'payee_middle_name': (str, none_type,),  # noqa: E501
            'payee_occupation': (str, none_type,),  # noqa: E501
            'payee_prefix': (str, none_type,),  # noqa: E501
            'payee_suffix': (str, none_type,),  # noqa: E501
            'pdf_url': (str, none_type,),  # noqa: E501
            'recipient_city': (str, none_type,),  # noqa: E501
            'recipient_committee': (committee_history.CommitteeHistory,),  # noqa: E501
            'recipient_committee_id': (str, none_type,),  # noqa: E501
            'recipient_name': (str, none_type,),  # noqa: E501
            'recipient_state': (str, none_type,),  # noqa: E501
            'recipient_zip': (str, none_type,),  # noqa: E501
            'ref_disp_excess_flg': (str, none_type,),  # noqa: E501
            'report_type': (str, none_type,),  # noqa: E501
            'report_year': (int, none_type,),  # noqa: E501
            'schedule_type': (str, none_type,),  # noqa: E501
            'schedule_type_full': (str, none_type,),  # noqa: E501
            'semi_annual_bundled_refund': (float, none_type,),  # noqa: E501
            'spender_committee_designation': (str, none_type,),  # noqa: E501
            'spender_committee_org_type': (str, none_type,),  # noqa: E501
            'spender_committee_type': (str, none_type,),  # noqa: E501
            'sub_id': (str,),  # noqa: E501
            'transaction_id': (str, none_type,),  # noqa: E501
            'two_year_transaction_period': (int, none_type,),  # noqa: E501
            'unused_recipient_committee_id': (str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None

    attribute_map = {
        'amendment_indicator': 'amendment_indicator',  # noqa: E501
        'amendment_indicator_desc': 'amendment_indicator_desc',  # noqa: E501
        'back_reference_schedule_id': 'back_reference_schedule_id',  # noqa: E501
        'back_reference_transaction_id': 'back_reference_transaction_id',  # noqa: E501
        'beneficiary_committee_name': 'beneficiary_committee_name',  # noqa: E501
        'candidate_first_name': 'candidate_first_name',  # noqa: E501
        'candidate_id': 'candidate_id',  # noqa: E501
        'candidate_last_name': 'candidate_last_name',  # noqa: E501
        'candidate_middle_name': 'candidate_middle_name',  # noqa: E501
        'candidate_name': 'candidate_name',  # noqa: E501
        'candidate_office': 'candidate_office',  # noqa: E501
        'candidate_office_description': 'candidate_office_description',  # noqa: E501
        'candidate_office_district': 'candidate_office_district',  # noqa: E501
        'candidate_office_state': 'candidate_office_state',  # noqa: E501
        'candidate_office_state_full': 'candidate_office_state_full',  # noqa: E501
        'candidate_prefix': 'candidate_prefix',  # noqa: E501
        'candidate_suffix': 'candidate_suffix',  # noqa: E501
        'category_code': 'category_code',  # noqa: E501
        'category_code_full': 'category_code_full',  # noqa: E501
        'comm_dt': 'comm_dt',  # noqa: E501
        'committee': 'committee',  # noqa: E501
        'committee_id': 'committee_id',  # noqa: E501
        'conduit_committee_city': 'conduit_committee_city',  # noqa: E501
        'conduit_committee_name': 'conduit_committee_name',  # noqa: E501
        'conduit_committee_state': 'conduit_committee_state',  # noqa: E501
        'conduit_committee_street1': 'conduit_committee_street1',  # noqa: E501
        'conduit_committee_street2': 'conduit_committee_street2',  # noqa: E501
        'conduit_committee_zip': 'conduit_committee_zip',  # noqa: E501
        'disbursement_amount': 'disbursement_amount',  # noqa: E501
        'disbursement_date': 'disbursement_date',  # noqa: E501
        'disbursement_description': 'disbursement_description',  # noqa: E501
        'disbursement_purpose_category': 'disbursement_purpose_category',  # noqa: E501
        'disbursement_type': 'disbursement_type',  # noqa: E501
        'disbursement_type_description': 'disbursement_type_description',  # noqa: E501
        'election_type': 'election_type',  # noqa: E501
        'election_type_full': 'election_type_full',  # noqa: E501
        'entity_type': 'entity_type',  # noqa: E501
        'entity_type_desc': 'entity_type_desc',  # noqa: E501
        'fec_election_type_desc': 'fec_election_type_desc',  # noqa: E501
        'fec_election_year': 'fec_election_year',  # noqa: E501
        'file_number': 'file_number',  # noqa: E501
        'filing_form': 'filing_form',  # noqa: E501
        'image_number': 'image_number',  # noqa: E501
        'line_number': 'line_number',  # noqa: E501
        'line_number_label': 'line_number_label',  # noqa: E501
        'link_id': 'link_id',  # noqa: E501
        'load_date': 'load_date',  # noqa: E501
        'memo_code': 'memo_code',  # noqa: E501
        'memo_code_full': 'memo_code_full',  # noqa: E501
        'memo_text': 'memo_text',  # noqa: E501
        'memoed_subtotal': 'memoed_subtotal',  # noqa: E501
        'national_committee_nonfederal_account': 'national_committee_nonfederal_account',  # noqa: E501
        'original_sub_id': 'original_sub_id',  # noqa: E501
        'payee_employer': 'payee_employer',  # noqa: E501
        'payee_first_name': 'payee_first_name',  # noqa: E501
        'payee_last_name': 'payee_last_name',  # noqa: E501
        'payee_middle_name': 'payee_middle_name',  # noqa: E501
        'payee_occupation': 'payee_occupation',  # noqa: E501
        'payee_prefix': 'payee_prefix',  # noqa: E501
        'payee_suffix': 'payee_suffix',  # noqa: E501
        'pdf_url': 'pdf_url',  # noqa: E501
        'recipient_city': 'recipient_city',  # noqa: E501
        'recipient_committee': 'recipient_committee',  # noqa: E501
        'recipient_committee_id': 'recipient_committee_id',  # noqa: E501
        'recipient_name': 'recipient_name',  # noqa: E501
        'recipient_state': 'recipient_state',  # noqa: E501
        'recipient_zip': 'recipient_zip',  # noqa: E501
        'ref_disp_excess_flg': 'ref_disp_excess_flg',  # noqa: E501
        'report_type': 'report_type',  # noqa: E501
        'report_year': 'report_year',  # noqa: E501
        'schedule_type': 'schedule_type',  # noqa: E501
        'schedule_type_full': 'schedule_type_full',  # noqa: E501
        'semi_annual_bundled_refund': 'semi_annual_bundled_refund',  # noqa: E501
        'spender_committee_designation': 'spender_committee_designation',  # noqa: E501
        'spender_committee_org_type': 'spender_committee_org_type',  # noqa: E501
        'spender_committee_type': 'spender_committee_type',  # noqa: E501
        'sub_id': 'sub_id',  # noqa: E501
        'transaction_id': 'transaction_id',  # noqa: E501
        'two_year_transaction_period': 'two_year_transaction_period',  # noqa: E501
        'unused_recipient_committee_id': 'unused_recipient_committee_id',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_from_server',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, _check_type=True, _from_server=False, _path_to_item=(), _configuration=None, _visited_composed_classes=(), **kwargs):  # noqa: E501
        """schedule_b.ScheduleB - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _from_server (bool): True if the data is from the server
                                False if the data is from the client (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            amendment_indicator (str, none_type): [optional]  # noqa: E501
            amendment_indicator_desc (str, none_type): [optional]  # noqa: E501
            back_reference_schedule_id (str, none_type): [optional]  # noqa: E501
            back_reference_transaction_id (str, none_type): [optional]  # noqa: E501
            beneficiary_committee_name (str, none_type): [optional]  # noqa: E501
            candidate_first_name (str, none_type): [optional]  # noqa: E501
            candidate_id (str, none_type):  A unique identifier assigned to each candidate registered with the FEC. If a person runs for several offices, that person will have separate candidate IDs for each office. . [optional]  # noqa: E501
            candidate_last_name (str, none_type): [optional]  # noqa: E501
            candidate_middle_name (str, none_type): [optional]  # noqa: E501
            candidate_name (str, none_type): Name of candidate running for office. [optional]  # noqa: E501
            candidate_office (str, none_type): [optional]  # noqa: E501
            candidate_office_description (str, none_type): [optional]  # noqa: E501
            candidate_office_district (str, none_type): [optional]  # noqa: E501
            candidate_office_state (str, none_type): [optional]  # noqa: E501
            candidate_office_state_full (str, none_type): [optional]  # noqa: E501
            candidate_prefix (str, none_type): [optional]  # noqa: E501
            candidate_suffix (str, none_type): [optional]  # noqa: E501
            category_code (str, none_type): [optional]  # noqa: E501
            category_code_full (str, none_type): [optional]  # noqa: E501
            comm_dt (date, none_type): [optional]  # noqa: E501
            committee (committee_history.CommitteeHistory): [optional]  # noqa: E501
            committee_id (str, none_type):  A unique identifier assigned to each committee or filer registered with the FEC. In general committee id&#39;s begin with the letter C which is followed by eight digits. . [optional]  # noqa: E501
            conduit_committee_city (str, none_type): [optional]  # noqa: E501
            conduit_committee_name (str, none_type): [optional]  # noqa: E501
            conduit_committee_state (str, none_type): [optional]  # noqa: E501
            conduit_committee_street1 (str, none_type): [optional]  # noqa: E501
            conduit_committee_street2 (str, none_type): [optional]  # noqa: E501
            conduit_committee_zip (int, none_type): [optional]  # noqa: E501
            disbursement_amount (float, none_type): [optional]  # noqa: E501
            disbursement_date (date, none_type): [optional]  # noqa: E501
            disbursement_description (str, none_type): [optional]  # noqa: E501
            disbursement_purpose_category (str, none_type): [optional]  # noqa: E501
            disbursement_type (str, none_type): [optional]  # noqa: E501
            disbursement_type_description (str, none_type): [optional]  # noqa: E501
            election_type (str, none_type): [optional]  # noqa: E501
            election_type_full (str, none_type): [optional]  # noqa: E501
            entity_type (str, none_type): [optional]  # noqa: E501
            entity_type_desc (str, none_type): [optional]  # noqa: E501
            fec_election_type_desc (str, none_type): [optional]  # noqa: E501
            fec_election_year (str, none_type): [optional]  # noqa: E501
            file_number (int, none_type): [optional]  # noqa: E501
            filing_form (str, none_type): [optional]  # noqa: E501
            image_number (str): [optional]  # noqa: E501
            line_number (str, none_type): [optional]  # noqa: E501
            line_number_label (str, none_type): [optional]  # noqa: E501
            link_id (int, none_type): [optional]  # noqa: E501
            load_date (datetime, none_type): [optional]  # noqa: E501
            memo_code (str, none_type): [optional]  # noqa: E501
            memo_code_full (str, none_type): [optional]  # noqa: E501
            memo_text (str, none_type): [optional]  # noqa: E501
            memoed_subtotal (bool): [optional]  # noqa: E501
            national_committee_nonfederal_account (str, none_type): [optional]  # noqa: E501
            original_sub_id (str): [optional]  # noqa: E501
            payee_employer (str, none_type): [optional]  # noqa: E501
            payee_first_name (str, none_type): [optional]  # noqa: E501
            payee_last_name (str, none_type): [optional]  # noqa: E501
            payee_middle_name (str, none_type): [optional]  # noqa: E501
            payee_occupation (str, none_type): [optional]  # noqa: E501
            payee_prefix (str, none_type): [optional]  # noqa: E501
            payee_suffix (str, none_type): [optional]  # noqa: E501
            pdf_url (str, none_type): [optional]  # noqa: E501
            recipient_city (str, none_type): [optional]  # noqa: E501
            recipient_committee (committee_history.CommitteeHistory): [optional]  # noqa: E501
            recipient_committee_id (str, none_type): [optional]  # noqa: E501
            recipient_name (str, none_type): [optional]  # noqa: E501
            recipient_state (str, none_type): [optional]  # noqa: E501
            recipient_zip (str, none_type): [optional]  # noqa: E501
            ref_disp_excess_flg (str, none_type): [optional]  # noqa: E501
            report_type (str, none_type): Name of report where the underlying data comes from:     - 10D Pre-Election     - 10G Pre-General     - 10P Pre-Primary     - 10R Pre-Run-Off     - 10S Pre-Special     - 12C Pre-Convention     - 12G Pre-General     - 12P Pre-Primary     - 12R Pre-Run-Off     - 12S Pre-Special     - 30D Post-Election     - 30G Post-General     - 30P Post-Primary     - 30R Post-Run-Off     - 30S Post-Special     - 60D Post-Convention     - M1  January Monthly     - M10 October Monthly     - M11 November Monthly     - M12 December Monthly     - M2  February Monthly     - M3  March Monthly     - M4  April Monthly     - M5  May Monthly     - M6  June Monthly     - M7  July Monthly     - M8  August Monthly     - M9  September Monthly     - MY  Mid-Year Report     - Q1  April Quarterly     - Q2  July Quarterly     - Q3  October Quarterly     - TER Termination Report     - YE  Year-End     - ADJ COMP ADJUST AMEND     - CA  COMPREHENSIVE AMEND     - 90S Post Inaugural Supplement     - 90D Post Inaugural     - 48  48 Hour Notification     - 24  24 Hour Notification     - M7S July Monthly/Semi-Annual     - MSA Monthly Semi-Annual (MY)     - MYS Monthly Year End/Semi-Annual     - Q2S July Quarterly/Semi-Annual     - QSA Quarterly Semi-Annual (MY)     - QYS Quarterly Year End/Semi-Annual     - QYE Quarterly Semi-Annual (YE)     - QMS Quarterly Mid-Year/ Semi-Annual     - MSY Monthly Semi-Annual (YE) . [optional]  # noqa: E501
            report_year (int, none_type):  Forms with coverage date -      year from the coverage ending date. Forms without coverage date -      year from the receipt date. . [optional]  # noqa: E501
            schedule_type (str, none_type): [optional]  # noqa: E501
            schedule_type_full (str, none_type): [optional]  # noqa: E501
            semi_annual_bundled_refund (float, none_type): [optional]  # noqa: E501
            spender_committee_designation (str, none_type): [optional]  # noqa: E501
            spender_committee_org_type (str, none_type): [optional]  # noqa: E501
            spender_committee_type (str, none_type): [optional]  # noqa: E501
            sub_id (str): [optional]  # noqa: E501
            transaction_id (str, none_type): [optional]  # noqa: E501
            two_year_transaction_period (int, none_type):  This is a two-year period that is derived from the year a transaction took place in the Itemized Schedule A and Schedule B tables. In cases where we have the date of the transaction (contribution_receipt_date in schedules/schedule_a, disbursement_date in schedules/schedule_b) the two_year_transaction_period is named after the ending, even-numbered year. If we do not have the date  of the transaction, we fall back to using the report year (report_year in both tables) instead,  making the same cycle adjustment as necessary. If no transaction year is specified, the results default to the most current cycle. . [optional]  # noqa: E501
            unused_recipient_committee_id (str, none_type): [optional]  # noqa: E501
        """

        self._data_store = {}
        self._check_type = _check_type
        self._from_server = _from_server
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in six.iteritems(kwargs):
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
